﻿' PARAMETERS ("Main","<car>|<message>|<zone>")
'--------------------------------------------------------------------------
'       	             GEO-FENCE integration for HOMESEER
'		by DJF3 - http://www.domoticaworld.com/projects/geofence-integration-homeseer/
' 0.2 - 18-Feb-2012 Full re-write. Script looks up Homeseer device based on the geo-fence name used at orange.gps-trace.com
' 0.1 - 22-Jan-2012 first try.
'	This script is executed by Jon00's Email plugin which triggers this even with contents of an email.
'	strDebug	Debug (0=off, 1=basic, 2=detailed)
'	-------------PARAMETERS	Note: the parameters are separated using pipes "|" !
'	strCar		- GPS tracking device
'	strMessage	- Message from GPS tracking device
'	strZone		- Where did <car> <enter/exit>? 
' TODO

Sub Main(ByVal varParameters)
	'--- Parameters
	
	Dim strDebug as Integer = 2
	Dim strGeoDevicesStartWith = "Car_Rolls_"
	Dim dv
	Dim strDevice as String
	Dim strCar as String = hs.stringitem(varParameters, 1, "|")
	Dim strMessage as String = hs.stringitem(varParameters, 2, "|")
	Dim strZone as String = hs.stringitem(varParameters, 3, "|")
	Dim varVersion as String = "DJ_GPS_GeoFence_0.2"
	If strDebug > 0 then hs.writelog(varVersion, "<b>Car:</b>" & strCar & "  <b>Message:</b>" & strMessage & "   <b>Zone:</b>" & strZone)
	If strCar = "" OR strMessage = "" or strZone = "" then
		hs.writelog (varVersion,"ERROR: One or more parameters are empty")
		Exit Sub
	End if

Try	' DJ: Scan ALL HS devices. If Dev.Name starts with <strGeoDevicesStartWith>: check if it matches the parameter
	' DJ: If _not_: set OFF if _yes_: set ON
	Dim en
	en = hs.GetDeviceEnumerator
	Do while not en.Finished
		if en.CountChanged then
			hs.WriteLog(varVersion & "_enum", "------- The device count has changed ------")
		end if
		dv = en.GetNext
		if not dv is nothing and Instr(dv.name, strGeoDevicesStartWith)>0 then
			strDevice = dv.hc & dv.dc
			If strDebug > 0 then hs.WriteLog(varVersion & "_enum", "Device (" & strDevice & ") - " & dv.name)
			If strZone = dv.name then 
				If strMessage = "ENTERED" then hs.runex("DJ_Twitter_05.vb","Main","CAR: your just " & strMessage & " ZONE " & strZone & "|prowl|Car")
				strMessage = Replace(strMessage,"ENTERED","ON")
				strMessage = Replace(strMessage,"LEFT","OFF")
				If strDebug > 1 then hs.writelog(varVersion,"<b>" & strZone & "</b> message is now <b>" & strMessage & "</b>")
				hs.execx10nolog(strDevice,strMessage)
				If strDebug > 1 then hs.writelog(varVersion,"swichted " & strMessage & " device " & strDevice & " to: " & strMessage)
			else
				hs.execx10nolog(strDevice,"OFF")
			End If
		end if
	Loop
Catch ex As Exception
	hs.writelog(varVersion,"Error message (" & ex.Message & ")")
End Try

End Sub



